# -*- coding: UTF-8 -*-

import wx

from outwiker.core.pluginbase import Plugin
from outwiker.core.commands import getCurrentVersion
from outwiker.core.version import Version

# Импортируем action
from actions import HelloAction


__version__ = u"0.0.4"

if getCurrentVersion() < Version (1, 8, 0, 742):
    print ("MyFirstPlugin. OutWiker version requirement: 1.8.0.742")
else:
    class PluginMyFirst (Plugin):
        """
        Простейший плагин
        """
        def __init__ (self, application):
            super (PluginMyFirst, self).__init__ (application)
            self.ID_HELLO = wx.NewId()
            self._menu = None


        @property
        def name (self):
            return u"MyFirstPlugin"


        @property
        def description (self):
            return u'''This is a first plugin'''


        @property
        def url (self):
            return u"http://example.com"


        @property
        def version (self):
            return __version__


        def initialize (self):
            # Регистрируем HelloAction
            self._application.actionController.register (
                HelloAction (self._application),
                None)

            # Проверим, что главное окно создано
            if self._application.mainWindow is not None:
                # Создадим меню "MyFirstPlugin"
                self._menu = wx.Menu()
                self._application.mainWindow.mainMenu.Insert (0, self._menu, u"MyFirstPlugin")

                # Cоздаем пункт меню для HelloAction
                self._application.actionController.appendMenuItem (
                    HelloAction.stringId,
                    self._menu)


        def destroy (self):
            # Проверим, что главное окно создано
            if self._application.mainWindow is not None:
                # Удалим созданный пункт меню
                self._application.actionController.removeMenuItem (HelloAction.stringId)

                # Найдем позицию нашего меню и удалим его
                pos = self._application.mainWindow.mainMenu.FindMenu (self._menu.GetTitle())
                if pos != wx.NOT_FOUND:
                    self._application.mainWindow.mainMenu.Remove (pos)

            # Удалим зарегистрированный action
            self._application.actionController.removeAction (HelloAction.stringId)
